#include <linux/circ_buf.h>

#define SSI_MAX_BUSSES   2
#define SSI_BUFSIZE      256

struct ssi_dev;

struct ssi_bus {
  spinlock_t        lock;
  int               minor;

  wait_queue_head_t waitq;
  
  u_int             rx_buf[SSI_BUFSIZE];
  size_t            rx_pos;
  size_t            rx_size;

  u_int             tx_buf[SSI_BUFSIZE];
  size_t            tx_pos;
  size_t            tx_size;

#ifdef CONFIG_DEVFS_FS
  devfs_handle_t  handle;
#endif /* CONFIG_DEVFS_FS */
  u_char	  cfglen;
  u_char	  framelen;
  u_char	  clkpol;
  u_char          clkpha;
  u_int           clkfreq;
  u_char	  proto;
  struct ssi_dev  *dev;		/* current device */
  int		  (*select) (struct ssi_bus *, struct ssi_dev *);
  int		  (*trans)  ( struct ssi_bus *, 
			      const u_int * buf , size_t len );
  int		  (*init)   (struct ssi_bus *);
  void		  (*exit)   (struct ssi_bus *);
  char		  *name;
  u_int		  devices;
};

extern int ssi_core_rcv(struct ssi_bus *bus, u_int *data , u_int length );
extern int ssi_register_bus(struct ssi_bus *bus);
extern int ssi_unregister_bus(struct ssi_bus *bus);
